(define *size* 5)
(define *button-size* 50)
(define *matrix* #f)

(define (make-matrix)
  (set! *matrix* (make-vector *size* #f))
  (do ((i 0 (1+ i)))
      ((>= i *size*) *matrix*)
    (vector-set! *matrix* i (make-vector *size* #f))))

(define (matrix-ref x y) (vector-ref (vector-ref *matrix* y) x))

(define (matrix-set! x y a) (vector-set! (vector-ref *matrix* y) x a))

(define (button-color x y) (if (matrix-ref x y) "#ff5" "#005"))

(define (push-button x y)
  (define (toggle x y)
    (and (>= x 0) (< x *size*) (>= y 0) (< y *size*)
         (begin
           (matrix-set! x y (not (matrix-ref x y)))
           (.c 'itemconfigure (+ (* x *size*) y 1)
               :fill (button-color x y)))))
  (let ((xx (truncate (/ x *button-size*)))
        (yy (truncate (/ y *button-size*))))
    (toggle xx (1- yy))
    (toggle (1- xx) yy)
    (toggle xx yy)
    (toggle (1+ xx) yy)
    (toggle xx (1+ yy))))

(define (init)
  (make-matrix)
  (matrix-set! 2 2 #t)
  (canvas '.c :height (* *button-size* *size*)
              :width (* *button-size* *size*))
  (.c 'bind 'rect "<1>" (lambda (%x %y) (push-button %x %y)))
  (do ((i 0 (1+ i)))
      ((>= i *size*))
    (do ((j 0 (1+ j)))
        ((>= j *size*))
      (let ((x1 (+ (* *button-size* i) 1)) (y1 (+ (* *button-size* j) 1)))
        (.c 'create 'rect x1 y1
                          (+ x1 (- *button-size* 2))
                          (+ y1 (- *button-size* 2))
            :outline 'black :fill (button-color i j) :tags 'rect))))
  (pack .c))

(define (start) (init) (tk:loop))

(start)
