; $BJQ?t@_Dj(B
(define *x-size* 15)
(define *y-size*  8)
(define *button-size* 40)
(define *gets* 0)
(define *rests* (* *x-size* *y-size*))
(define *total* (- 0 *rests*))
(define *width* *x-size*)
(define *bg-color* "#004")
(define *matrix* #f)
(define *color*
  (vector *bg-color* '"#44f" '"#f42" '"#ff2" '"#4f4" '"#d5f"))
(define *name*  (make-vector 11 0))
(define *score* (make-vector 11 0))

; $BG[Ns:n@.(B
(define (make-matrix)
  (set! *matrix* (make-vector *y-size* #f))
  (do ((i 0 (1+ i)))
      ((>= i *y-size*) *matrix*)
      (vector-set! *matrix* i (make-vector *x-size* 0))))

(define (matrix-ref x y) (vector-ref (vector-ref *matrix* y) x))

(define (matrix-set! x y a) (vector-set! (vector-ref *matrix* y) x a))

(define (button-color x y) (vector-ref *color* (matrix-ref x y)))

(define (read-score)
  (define in (open-input-file "/usr/local/lib/tustk/demos/samegame.scr"))
  (do ((i 1 (1+ i)))
      ((> i 10))
      (vector-set! *name*  i (read in))
      (vector-set! *score* i (read in)))
  (close-input-port in))

(define (ranking x)
  (define (clear-rank)
    (.c 'delete 'rank))
  (.c 'create 'rectangle 200 30 400 290 :fill *bg-color*
      :outline 'white :width 5 :tags 'rank)
  (.c 'create 'text 300 50 :anchor 'center
      :fill 'white :tags 'rank :text "<< Score Ranking >>")
  (do ((i 1 (1+ i)))
      ((> i 10))
      (.c 'create 'text 235 (+ (* i 21) 54) :anchor 'e
	  :fill (if (= x i) 'yellow 'white) :tags 'rank :text i)
      (.c 'create 'text 330 (+ (* i 21) 54) :anchor 'e
	  :fill (if (= x i) 'yellow 'white) :tags 'rank
	  :text (vector-ref *name* i))
      (.c 'create 'text 380 (+ (* i 21) 54) :anchor 'e
	  :fill (if (= x i) 'yellow 'white) :tags 'rank
	  :text (vector-ref *score* i)))
  (.c 'bind 'rank "<Button>" (lambda () (clear-rank))))

(define (newgame)
  (do ((i 0 (1+ i)))
      ((>= i *x-size*))
      (do ((j 0 (1+ j)))
          ((>= j *y-size*))
          (matrix-set! i j (+ (random 5) 1 ))  
	  (.c 'itemconfigure (+ (* i *y-size*) j 1)
	      :fill (button-color i j))))
  (set! *width* *x-size*)
  (set! *gets* 0)
  (set! *rests* (* *x-size* *y-size*))
  (set! *total* (- 0 *rests*))
  (.f.va1 'configure :text *gets*)
  (.f.va2 'configure :text *rests*)
  (.f.va3 'configure :text *total*))

; $B%&%#%s%I%&$N@_Dj(B
(define (setup)
  (wm 'title '. '"SameGame  for  Tus/Tk")
  (label '.title :text "SameGame for Tus/Tk  by Yasuhiro Kamiya 1996"
	 :bd 2 :relief 'raised)
  (canvas '.c :height (* *button-size* *y-size*)       ; $B%-%c%s%P%9:n@.(B
              :width (* *button-size* *x-size*) :bg *bg-color*)
  (frame  '.f :borderwidth 2 :relief 'raised)
  (label  '.f.l1 :text "Gets :" :relief 'flat)
  (label  '.f.va1 :text "0" :relief 'sunken)
  (label  '.f.l2 :text "Rests :" :relief 'flat)
  (label  '.f.va2 :text *rests* :relief 'sunken)
  (label  '.f.l3 :text "Total :" :relief 'flat)
  (label  '.f.va3 :text *total* :relief 'sunken)
  (button '.f.b1 :text "New Game" :command (lambda () (newgame)))
  (button '.f.b2 :text "Quit" :command (lambda () (destroy '.)))
  (.c 'bind 'oval "<1>" (lambda (%x %y) (push-button %x %y)))
  (bind '.c "<2>" (lambda () (newgame)))
  (bind '.c "<3>" (lambda () (ranking 0)))

  (do ((i 0 (1+ i)))
      ((>= i *x-size*))
      (do ((j 0 (1+ j)))
	  ((>= j *y-size*))
	  (matrix-set! i j (+ (random 5) 1 ))  ; $B%i%s%@%`$KG[?'(B
	  (let ((x1 (+ (* *button-size* i) 3)) (y1 (+ (* *button-size* j) 3)))
	    (.c 'create 'oval x1 y1
		(+ x1 (- *button-size* 6))
		(+ y1 (- *button-size* 6))
		:outline *bg-color* :fill (button-color i j) :tags 'oval
		:width 2))))
  (pack .title .c .f :side 'top :fill 'both :expand 1)
  (pack .f.l1 .f.va1 .f.l2 .f.va2 .f.l3 .f.va3 .f.b1 .f.b2
	:side 'left :fill 'both :expand 1))

; $B>C$;$J$$$+%A%'%C%/(B
(define (check-alone x y)
  (let ((*col* (matrix-ref x y)))
    (if	(and (or (= x 0) (not (= *col* (matrix-ref (- x 1) y))))
	     (or (= x (- *x-size* 1)) (not (= *col* (matrix-ref (+ x 1) y))))
	     (or (= y 0) (not (= *col* (matrix-ref x (- y 1)))))
	     (or (= y (- *y-size* 1)) (not (= *col* (matrix-ref x (+ y 1))))))
	#t #f)))

(define (group x y)
  (define *list* (list (list x y) ))  ; $B%j%9%H(B
  (define *col* (matrix-ref x y))     ; $B?'(B
  (define *numb* 1)                   ; $B8D?t(B
  (define *pointer* 1)                ; $B%]%$%s%?(B
  (define *check-mat* #f)             ; $B%A%'%C%/MQG[Ns(B
  (define (che-mat-ref x y) (vector-ref (vector-ref *check-mat* y) x))

  (define (search x y)  ; $BNY@\4X78$r%A%'%C%/(B
    (if (and (> x 0) (= 0 (che-mat-ref (- x 1) y)))              ; $B:8(B
	(if (= *col* (matrix-ref (- x 1) y))
	    (begin (set! *numb* (+ *numb* 1))
		   (set! *list* (append *list* (list (list (- x 1) y))))
		   (vector-set! (vector-ref *check-mat* y) (- x 1) 1))
	  (vector-set! (vector-ref *check-mat* y) (- x 1) 2)))
    (if (and (< x (- *x-size* 1)) (= 0 (che-mat-ref (+ x 1) y))) ; $B1&(B
	(if (= *col* (matrix-ref (+ x 1) y))
	    (begin (set! *numb* (+ *numb* 1))
		   (set! *list* (append *list* (list (list (+ x 1) y))))
		   (vector-set! (vector-ref *check-mat* y) (+ x 1) 1))
	  (vector-set! (vector-ref *check-mat* y) (+ x 1) 2)))
    (if (and (> y 0) (= 0 (che-mat-ref x (- y 1))))              ; $B>e(B
	(if (= *col* (matrix-ref x (- y 1)))
	    (begin (set! *numb* (+ *numb* 1))
		   (set! *list* (append *list* (list (list x (- y 1)))))
		   (vector-set! (vector-ref *check-mat* (- y 1)) x 1))
	  (vector-set! (vector-ref *check-mat* (- y 1)) x 2)))
    (if (and (< y (- *y-size* 1)) (= 0 (che-mat-ref x (+ y 1)))) ; $B2<(B
	(if (= *col* (matrix-ref x (+ y 1)))
	    (begin (set! *numb* (+ *numb* 1))
		   (set! *list* (append *list* (list (list x (+ y 1)))))
		   (vector-set! (vector-ref *check-mat* (+ y 1)) x 1))
	  (vector-set! (vector-ref *check-mat* (+ y 1)) x 2)))
    (if (> *numb* *pointer*)
	(begin (set! *pointer* (+ *pointer* 1))
	       (set! x (car  (nth (- *pointer* 1) *list*)))
	       (set! y (cadr (nth (- *pointer* 1) *list*)))
	       (search x y))))

  (define (score) ; $B%9%3%"(B
    (define (point p)
      (let ((q (- p 2)))
	(* q q)))
    (set! *gets* (+ *gets* (point *numb*)))
    (set! *rests* (- *rests* *numb*))
    (set! *total* (+ *total* (point *numb*) *numb*))
    (.f.va1 'configure :text *gets*)
    (.f.va2 'configure :text *rests*)
    (.f.va3 'configure :text *total*))

  (define (erase) ; $B>C$9(B
    (define *pointer* (- *y-size* 1))
    (define *sum* 0)
    (define *height* *y-size*)
    (define (che-mat-ref x y) (vector-ref (vector-ref *check-mat* y) x))
    (do ((xx 0 (1+ xx)))
	((>= xx *width*))
	(set! *pointer* (- *y-size* 1))
	(set! *sum* 0)
	(set! *height* *y-size*)
	(do ((j 0 (1+ j)))
	    ((not (= 0 (matrix-ref xx j))))
	    (set! *height* (- *height* 1)))
	(do ((yy (- *y-size* 1) (1- yy)))
	    ((< yy 0))
	    (if (not (= 1 (che-mat-ref xx yy)))  ; $BMn$H$9(B
		(begin
		 (matrix-set! xx *pointer* (matrix-ref xx yy))
		 (.c 'itemconfigure (+ (* xx *y-size*) *pointer* 1)
		     :fill (button-color xx *pointer*))
		 (set! *pointer* (- *pointer* 1)))
	      (set! *sum* (+ *sum* 1)))
	    )
	(do ((i (- *y-size* *height*) (1+ i)))  ; $B>C$9(B
	    ((>= i (+ (- *y-size* *height*) *sum*)))
	    (matrix-set! xx i 0)
	    (.c 'itemconfigure (+ (* xx *y-size*) i 1)
		:fill (button-color xx i)))
	))

  (define (closer) ; $B$:$i$9(B
    (define *skip* 0)
    (do ((xx 0 (1+ xx)))
	((>= xx *width*))
	(if (= 0 (matrix-ref xx (- *y-size* 1)))
	    (begin
	     (set! *skip* 1)
	     (do ((i 1 (1+ i)))
		 ((or (not (= 0 (matrix-ref (+ xx i) (- *y-size* 1))))
		      (>= (+ xx i) *width*)))
		 (set! *skip* (+ *skip* 1)))
	     (do ((yy 0 (1+ yy)))
		 ((>= yy *y-size*))
		 (do ((xxx xx (1+ xxx)))
		     ((>= xxx (- *x-size* *skip*)))
		     (matrix-set! xxx yy (matrix-ref (+ xxx *skip*) yy))
		     (.c 'itemconfigure (+ (* xxx *y-size*) yy 1)
			 :fill (button-color xxx yy)))
		 (do ((i *skip* (1- i)))
		     ((<= i 0))
		     (matrix-set! (- *x-size* i) yy 0)
		     (.c 'itemconfigure (+ (* (- *x-size* i) *y-size*) yy 1)
			 :fill (button-color (- *x-size* i) yy))))
	     (set! *width* (- *width* *skip*))))))

  (define (fin) ; $B=*N;=hM}(B
    (define out (open-output-file "../samegame.scr"))
    (define *rank* 11)
    (do ((i 10 (1- i)))
	((or (<= i 0) (< *total* (vector-ref *score* i))))
	(set! *rank* (- *rank* 1)))
    (if (<= *rank* 10)
	(begin
	 (do ((i 10 (1- i)))
	     ((>= *rank* i))
	     (vector-set!  *name* i (vector-ref  *name* (- i 1)))
	     (vector-set! *score* i (vector-ref *score* (- i 1))))
	 (vector-set!  *name* *rank* (getenv "LOGNAME"))
	 (vector-set! *score* *rank* *total*)))
    (do ((i 1 (1+ i)))
	((> i 10))
	(display (vector-ref  *name* i) out)(display " " out)
	(display (vector-ref *score* i) out)(newline out))
    (close-output-port out)
    (ranking *rank*))

  (define (end-check) ; $B=*N;$7$F$$$k$+%A%'%C%/(B
    (define *flag* 0)
    (do ((xx 0 (1+ xx)))
	((or (= 1 *flag*) (>= xx *width*)))
	(do ((yy (- *y-size* 1) (1- yy)))
	    ((or (= 1 *flag*) (= 0 (matrix-ref xx yy))))
	    (if (and (not (= yy 0))
		     (= (matrix-ref xx yy) (matrix-ref xx (- yy 1))))
		(set! *flag* 1))
	    (if (and (not (= xx (- *x-size* 1)))
		     (= (matrix-ref xx yy) (matrix-ref (+ xx 1) yy)))
		(set! *flag* 1))))
    (if (= *flag* 0)
	(fin)))

  (set! *check-mat* (make-vector *y-size* #f))
  (do ((i 0 (1+ i)))
      ((>= i *y-size*) *check-mat*)
      (vector-set! *check-mat* i (make-vector *x-size* 0)))
  (vector-set! (vector-ref *check-mat* y) x 1)   ; $B=PH/E@$O#1(B
  (search x y)
  (score)
  (erase)
  (closer)
  (end-check))

(define (push-button x y)
  (let* ((xx (truncate (/ x *button-size*)))
	 (yy (truncate (/ y *button-size*)))
	 (*cur-color* (button-color xx yy)))
    (if (and (not (check-alone xx yy))
	     (not (= 0 (matrix-ref xx yy))))
	(group xx yy))))

(define (init)
  (read-score)
  (make-matrix)
  (setup))

(define (start) (init) (tk:loop))

(start)
